package cokr.xit.fims.levy.web;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import cokr.xit.base.web.ApplicationController;
import cokr.xit.fims.levy.Levy;
import cokr.xit.fims.levy.LevyQuery;
import cokr.xit.fims.levy.service.Levy01Service;

/**부과 대장 서비스의 웹 컨트롤러
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-30	JoJH 최초 작성
 * ================================
 * </pre>
 */
public class Levy01Controller extends ApplicationController {

	/**부과 대장 서비스*/
	@Resource(name = "levy01Service")
	private Levy01Service levy01Service;

	/**부과 대장 관리 메인화면(levy/levy-main)을 연다.
	 * 조건없는 {@link #getLevyList(LevyQuery) 부과 대장 조회 결과}를 포함시킨다.
	 * @return /levy/levy-main
	 */
	@RequestMapping(name = "부과 대장 메인", value = "/010/main.do")
	public ModelAndView main() {
		ModelAndView mav = getLevyList(new LevyQuery().setPageNum(1));

		mav.setViewName("/levy/levy-main");

		return mav.addObject("levyList", toJson(mav.getModel().get("levyList")));
	}

	/**부과 대장 목록을 조회하여 반환한다.<br />
	 * {@link LevyService#getLevyList(LevyQuery)} 참고
	 * @param req 부과 대장 조회 조건
	 * @return jsonView
	 * <pre><code> {
	 *     "levyList": [부과 대장 목록]
	 *     "levyStart": 부과 대장 목록 시작 인덱스
	 *     "levyFetch": 한 번에 가져오는 부과 대장 목록 수
	 *     "levyTotal": 조회 결과 찾은 전체 부과 대장 수
	 * }</code></pre>
	 */
	@RequestMapping(name = "부과 대장 조회", value = "/010/list.do")
	public ModelAndView getLevyList(LevyQuery req) {
		List<?> result = levy01Service.getLevyList(setFetchSize(req));

		return setCollectionInfo(new ModelAndView("jsonView"), result, "levy");
	}

	/**부과 대장를 등록한다.
	 * @param levy 부과 대장 정보
	 * @return jsonView
	 * <pre><code> {
	 *     "saved": 등록되었으면 true, 그렇지 않으면 false
	 * }</code></pre>
	 */
	@PostMapping(name = "부과 대장 등록", value = "/010/create.do")
	public ModelAndView createLevy(Levy levy) {
		boolean saved = levy01Service.createLevy(levy);

		return new ModelAndView("jsonView")
			.addObject("saved", saved);
	}

	/**부과 대장 정보를 수정한다.
	 * @param levy 부과 대장 정보
	 * @return jsonView
	 * <pre><code> {
	 *     "saved": 수정되었으면 true, 그렇지 않으면 false
	 * }</code></pre>
	 */
	@PostMapping(name = "부과 대장 수정", value = "/010/update.do")
	public ModelAndView updateLevy(Levy levy) {
		boolean saved = levy01Service.updateLevy(levy);

		return new ModelAndView("jsonView")
			.addObject("saved", saved);
	}

	/**지정한 부과 대장를 제거한다.
	 * @param levyId 부과 대장 ID
	 * @return jsonView
	 * <pre><code> {
	 *     "affected": 저장된 정보수
	 *     "saved": 저장되었으면 true, 그렇지 않으면 false
	 * }</code></pre>
	 */
	@PostMapping(name = "부과 대장 제거", value = "/010/remove.do")
	public ModelAndView removeLevy(Levy levy) {
		boolean saved = levy01Service.removeLevy(levy);

		return new ModelAndView("jsonView")
			.addObject("saved", saved);
	}

	/**여러 건의 부과 대장를 제거한다.
	 * @param rductIDs 부과 대장 IDs
	 * @return jsonView
	 * <pre><code> {
	 *     "affected": 저장된 정보수
	 *     "saved": 저장되었으면 true, 그렇지 않으면 false
	 * }</code></pre>
	 */
	@PostMapping(name="의견제출 대장 제거", value="/010/removes.do")
	public ModelAndView removeLevys(LevyQuery req) {
		boolean saved = levy01Service.removeLevys(req);

		return new ModelAndView("jsonView")
			.addObject("saved", saved);
	}

}
